def bot_callback(bot, message):
    command = message.get("command")
    params = message.get("params")
    has_tags = message.get("has_tags")
    tags = message.get("tags", dict())
    account = tags.get("account")
    settings = bot.state.get("settings", dict())
    irc_settings = settings.get("irc", dict())
    author = irc_settings.get("author", "aewens")
    farewell = irc_settings.get("farewell", "Bye-bye!")

    if command == "ERROR":
        bot.state["stop"] = True
        bot.send("QUIT :encountered error!")

    if command == "PING":
        bot.send(f"PONG :{params}")

    # NOTE - Your code goes here
    if command == "PRIVMSG" and bot.state.get("joined"):
        NotImplemented

    if command == "INVITE":
        name, channel = params.split(" ", 1)
        bot.join(channel)

    if all([command == "PRIVMSG", bot.state.get("joined"), has_tags,
        account == author]):
        channel, privmsg = bot.privmsg(message)
        if privmsg.startswith("!join"):
            action, chan = privmsg.split(" ", 1)
            bot.join(chan)

        if privmsg.startswith("!leave"):
            action, chan = privmsg.split(" ", 1)
            bot.leave(chan, farewell)
