def bot_callback(bot, message):
    command = message.get("command")
    params = message.get("params")
    has_tags = message.get("has_tags")
    has_prefix = message.get("has_prefix")
    raw = message.get("raw")
    cmd_type = message.get("type")
    source = message.get("source")
    nick = message.get("nick")

    settings = bot.state.get("settings", dict())
    irc_settings = settings.get("irc", dict())
    bot_name = irc_settings.get("name", "ircbot")

    flags = bot.state.get("_flags")

    if all([source == "server", command == "NOTICE", not bot.state.get("init"),
        "Looking up your hostname" in params]):
        flags["init"] = True
        flags["caps"] = False
        bot.send("CAP LS")

    if all([source == "server", command == "CAP", not bot.state.get("caps"),
        "* LS" in params]):
        capabilities = params.split("* LS", 1)[1].strip()
        requirements = irc_settings.get("requirements", list())
        reqs = requirements[:]
        acceptable = False
        for cap in capabilities.split(" "):
            if cap in reqs:
                reqs.remove(cap)
                if len(reqs) == 0:
                    acceptable = False
                    break

        if acceptable or len(reqs) == 0:
            req_caps = " ".join(requirements)
            bot.send(f"CAP REQ :{req_caps}")

        else:
            flags["stop"] = True

    if all([source == "server", command == "CAP", not bot.state.get("caps"),
        "* ACK" in params]):
        flags["caps"] = True
        bot.send("CAP END")
        bot.send(f"USER {bot_name} - - -")
        bot.send(f"NICK {bot_name}")

    if all([source == "nick", nick == "NickServ", command == "NOTICE",
        not bot.state.get("identify"), any(["choose a different nick" in params,
        "Your nickname is not registered" in params])]):
        bot_pass = irc_settings.get("password", "password")
        flags["identify"] = True
        bot.send(f"PRIVMSG NickServ :IDENTIFY {bot_name} {bot_pass}")

    if all([source == "nick", nick == "NickServ", command == "MODE",
        bot.state.get("identify"), "+r" in params]):
        flags["registered"] = True
        channels = irc_settings.get("auto-join", list())
        for channel in channels:
            bot.join(channel)

        flags["joined"] = True
